;*********************************************************************************************************************
;ADRESA I IMENA
;--------------------------------------------------------------------------------------------------------
				                  ;SPEC REGISTRI
TCON         EQU 088H
TMOD         EQU 089H
TL0          EQU 08AH
TL1          EQU 08BH
TH0          EQU 08CH
TH1          EQU 08DH
AUXR         EQU 08EH
IP           EQU 0B8H
IE           EQU 0A8H

EA           BIT 0AFH
ET0          BIT 0A9H

				                  ;ADRESA PORTOV
P0           EQU 080H			     
P1           EQU 090H	             
P2           EQU 0A0H
P3           EQU 0B0H
                                  ;ADRESA BITOV PORTOV
SYEN         EQU 0B5H
SYDA         EQU 0B4H
SYCL         EQU 0B1H
SINC_SLOT    EQU 0B0H
INT0         EQU 0B2H
INT1         EQU 0B3H

TST          EQU 0A3H
RS           EQU 0A2H
RW           EQU 0A1H
E			 EQU 0A0H
					              ;ADRESA YACEEK
SINDATA1     EQU 008H  
SINDATA2     EQU 009H                 
CANALX       EQU 00AH              
LCDADR		 EQU 00BH
LCDDATA      EQU 00CH

PAK0		 EQU 00DH
PAK1		 EQU 00EH
PAK2		 EQU 00FH
PAK3		 EQU 010H
PAK4		 EQU 011H
PAK5		 EQU 012H

RFPI1        EQU 013H
RFPI2        EQU 014H
RFPI3        EQU 015H
RFPI4        EQU 016H
RFPI5        EQU 017H
N_CAN        EQU 018H
ERROR_RFPI   EQU 019H

KEY1         EQU 01BH
KEY2         EQU 01CH
KEYOFFTIME   EQU 01DH
KEYONTIME    EQU 01EH
KEYVEL       EQU 01FH

TEMP_PAK1    EQU 030H
TEMP_PAK2    EQU 031H
TEMP_PAK3    EQU 032H
TEMP_PAK4    EQU 033H
TEMP_PAK5    EQU 034H

KEYOFF       BIT 000H              ;BIT OTPUSK
KEYON        BIT 001H              ;BIT SRABOTKI KLAVIATURI
SCAN         BIT 002H
BAZAR_PAK    BIT 003H
SLOT_SINC	 BIT 004H
SCAN_PAK     BIT 005H
;*********************************************************************************************************************


;*********************************************************************************************************************
;SISTEMNAYA INICALIZACIYA
;--------------------------------------------------------------------------------------------------------


	         ORG 0000H	           ;OSVOBOGDENIE MESTA
	         JMP START

			 ORG 0003H             ;PRERYVANIE  VNESNEE 0
			 JMP PAKET             ;PRERIVANIE PAKETA

			 ORG 000BH             ;PRERYVANIE  TIMERA 0
			 JMP TimerKL           ;PRERIVANIE OPROSA KLAVIATURI

			 ORG 0013H             ;PRERYVANIE  VNESNEE 1
			 RETI                  ;ZAGLUSKA

			 ORG 001BH             ;PRERYVANIE  TIMERA 1
			 RETI                  ;ZAGLUSKA

			 ORG 0023H             ;PRERYVANIE  OT COM PORTA
			 RETI                  ;ZAGLUSKA


	         ORG 0060H			   ;OSVOBOGDENIE MESTA OCONCANIE
START:		 CLR EA                ;PRERIVANIY ZAGLUSENI
             MOV SP,#60H           ;ADRES WERSINI STECA
			 MOV AUXR,#00000001B   ;KONFIGURACIYA ALE
			 MOV TH0,0FFH		   ;KONFIGURACIYA TIMER NACALO
			 MOV TL0,0FFH
			 MOV TMOD,#00000010B   ;KONFIGURACIYA TIMER
			 MOV IE,#00000011B     ;KONFIGURACIYA PRERIVANIA  (0-BIT	VNESNEE INT0)  (1-BIT TIMER0)
			 MOV TCON,#00010101B   ;RAZRESENIE SCETA TIMER 0 I CONFIGURACIYA FRONTOV VNESNIX PRERIVANIY
			 MOV IP,#00000001B     ;PRIORITET PRERIVANIIY 
;*********************************************************************************************************************


;*********************************************************************************************************************
;PROGRAMNAYA INICIALIZACIYA
;--------------------------------------------------------------------------------------------------------
             
             MOV ERROR_RFPI,#000H
             MOV P0,#0FFH		   ;OT PREREKOSA
			 CLR KEYON
			 CLR SCAN
			 CLR TST
			 CLR SLOT_SINC
			 CLR SCAN_PAK
			 CLR SINC_SLOT
			 SETB INT0
			 SETB INT1             ;OT PREREKOSA
			 CLR BAZAR_PAK
			 MOV N_CAN,#000H       ;OCISTIT CANAL
		     MOV SINDATA1,#0B8H    ;STARSIE 5 BIT KONSTANTA SINTEZA
             MOV KEYOFFTIME,#0FFH
		     MOV KEYONTIME,#0FFH
			 MOV KEYVEL,#001H
			 CALL ZADO             ;ZADERGKA DLY INDIKATORA
			 CALL INTLCD
			 CALL ZADO             ;ZADERGKA DLY INDIKATORA
			 CALL PRINT_TXT_MAC    
			 CALL PRINT_TXT_KANAL
			 SETB EA               ;RAZRESENIE PRERIVANIY
			 JMP OPROS

ZADO:						       ;ZADERGKA DLA RAZNIX PRIMENENIY
			 MOV R7,#0FFH
ZD:
             NOP
             DJNZ R7,ZD
			 RET
;*********************************************************************************************************************












;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;GLAVNIIY MODUL
;--------------------------------------------------------------------------------------------------------
OPROS:
				   JB KEYON,KLV_KAKAYA    ;PROVERCA SRABOTKI KLAVIATURI
				   JNB SCAN,OPROS1        ;ESLI VKLUCEN SCAN TO 
				   CALL SKAN_RF			  ;VIZOV SCANA
OPROS1:		   		   
				   JMP OPROS              ;ZACIKLENNO
;--------------------------------------------------------------------------------------------------------





;OPREDILENIE KNOPOK I OBRABOTKA FUNKCIY NAGATIYA
;--------------------------------------------------------------------------------------------------------
KLV_KAKAYA:
                  
	               MOV A,KEYVEL		     ;NOMER KNOPKI V BUFER
				   RL  A				 ;?
	               MOV DPTR,#KEY_PEREX	 ;ADRES METKI PEREXODOV	V DPTR
	               JMP @A+DPTR			 ;VICISLAEMIY PEREXOD

KEY_PEREX:		   JMP SINT_LCD_L0AD     
                   JMP SINT_LCD_L0AD
				   JMP SINT_LCD_L0AD
				   JMP SINT_LCD_L0AD
				   JMP SINT_LCD_L0AD
				   JMP SINT_LCD_L0AD
				   JMP SINT_LCD_L0AD
				   JMP SINT_LCD_L0AD
				   JMP SINT_LCD_L0AD
				   JMP SINT_LCD_L0AD
				   JMP KEY_SLOT_SINC	 ;ESLI A TO	SHIFT
                   JMP KEY_RF_SCAN		 ;ESLI B TO ENTER (KEY_RF_SCAN)
				   JMP ENA_EMUL          ;ESLI C TO x
				   JMP SBROSKLV          ;ESLI D TO -
				   JMP FILTR_AUD         ;ESLI E TO +
				   JMP SET_SINC          ;ESLI F TO =
;--------------


FILTR_AUD:
			       JB INT1,CLR_FILTR_AUD
				   SETB INT1
				   CALL	PRINT_F
				   JMP SBROSKLV
CLR_FILTR_AUD:
				   CLR INT1
				   CALL CLR_F
				   JMP SBROSKLV

;--------------
ENA_EMUL:          
                   JB TST,ENA_EMUL_CLR	 ;ESLI BIT UGE STOIT PEREXOD NA SBROS
				   SETB TST
				   CALL PRINT_E			 ;
				   JMP SBROSKLV

ENA_EMUL_CLR:
				   CLR TST
				   CALL CLR_E
				   JMP SBROSKLV
;--------------

;--------------
SINT_LCD_L0AD:     
				   CLR SLOT_SINC         ;SBROS SLOT SINXRONIZACII
				   CALL	CLR_S            ;STERET SIMVOL SINXRONIZACII
				   CLR SCAN_PAK          ;ZAPRET POISKA BAZARA
				   MOV RFPI1,#000H	     ;SBROS YCEEK SINXRONIZACII
				   MOV RFPI2,#000H
				   MOV RFPI3,#000H
				   MOV RFPI4,#000H
				   MOV RFPI5,#000H
				   CALL PRINT_TXT_MAC     ;STERET STRIY RFPI S EKRANA
           
				   MOV A,KEYVEL			 ;NOMER KNOPKI V BUFER
				   MOV DPTR,#SINTTAB     ;ADRES TABLICI SINTEZA V DPTR
				   MOVC A,@A+DPTR        ;IZVLECENIE CISLA SINTEZA IZ TABLICI
				   CALL LOAD             ;VIZOV ZAPISI
				   NOP
				   MOV LCDADR,#006H
				   CALL set_lcd_adr
				   MOV A,KEYVEL
				   ADD A,#030H
				   MOV LCDDATA,A
				   CALL print_char
				   JMP SBROSKLV
;--------------



;--------------
KEY_SLOT_SINC:
                   JB SLOT_SINC,CLRS     ;ESLI BIT UGE STOIT PEREXOD NA SBROS
				   SETB SLOT_SINC	     ;PODNYAT EGO
				   CALL PRINT_S
				   JMP SBROSKLV

CLRS:              
                   CLR SLOT_SINC	     ;SBROSIT EGO
				   CALL CLR_S            ;
				   JMP SBROSKLV
;--------------





;--------------
KEY_RF_SCAN:
                   JBC SCAN,SBROSKLV     ;ESLI BIT UGE STOIT SBROSIT I VIXOD
				   SETB SCAN			 ;PODNYAT EGO
				   JMP SBROSKLV
;--------------



;ZAXVAT RAZGOVORA =
;---------------------------------------------------------------------------------------------------------------------
SET_SINC:								 ;RUCNOY ZAXVAT RAZGOVORA RFPI I SINXRONIZACII
                   CLR SLOT_SINC         ;SBROS SLOT SINXRONIZACII
				   CLR SCAN_PAK          ;ZAPRET POISKA BAZARA
				   CALL	CLR_S            ;STERET SIMVOL SINXRONIZACII
				   MOV TEMP_PAK1,#000H	 ;SBROS STARIX MAC ADRESOV
				   MOV TEMP_PAK2,#000H
				   MOV TEMP_PAK3,#000H
				   MOV TEMP_PAK4,#000H
				   MOV TEMP_PAK5,#000H
				   MOV RFPI1,#000H	     ;SBROS YCEEK SINXRONIZACII
				   MOV RFPI2,#000H
				   MOV RFPI3,#000H
				   MOV RFPI4,#000H
				   MOV RFPI5,#000H
				   CALL PRINT_TXT_MAC    ;STERET STRIY RFPI S EKRANA
				   MOV R3,#00FH			 ;SCETCIK PROXODOV
				   CLR ET0               ;PRERIVANIE KLAVIATURY ZAGLUSENO
				   CLR BAZAR_PAK	     ;SBROS OBNARUZENIE PAKETA
				   SETB SCAN_PAK         ;RAZRESENIE POISKA BAZARA
met3:
                   CALL ZADO      		 ;ZADERGKA
				   JB BAZAR_PAK,BAZAR2	 ;ESLI 1 TO BAZAR POTTVERGDEN
				   DJNZ R3,met3			 ;PROVERIT SCETCIK PROXODOV ESLI ON ZACONCILIS TO VIXOD

				   SETB ET0              ;PRERIVANIE KLAVIATURY RAZRESENO
				   CLR SCAN_PAK          ;ZAPRET POISKA BAZARA
				   JMP SBROSKLV
BAZAR2:            
                   SETB ET0              ;PRERIVANIE KLAVIATURY RAZRESENO
                   CLR SCAN_PAK          ;ZAPRET POISKA BAZARA
				   CLR BAZAR_PAK	     ;SBROS OBNARUZENIE PAKETA
                   SETB SLOT_SINC        ;PODNATIE SLOT SINXRONIZACII
				   CLR SCAN			     ;OCISTIT BIT SCANA
                   CALL PRINT_MAC		 ;VIVESTI NOVIY RFPI
				   CALL PRINT_S          ;USTANOVIT SIMVOL SINXRONIZACII
				   JMP SBROSKLV

;--------------
SBROSKLV:
				   CLR KEYOFF			 ;OCISTIT BIT OTPUSK
BITOTPUSK:
				   JB  KEYOFF,CLRKEYON   ;OGIDANIE OTPUSCANIY
				   JMP BITOTPUSK		 ;ZACIKLENNO
CLRKEYON:
                   CLR KEYON
				   JMP OPROS 
;--------------------------------------------------------------------------------------------------------





;POISK RAZGOVORA
;--------------------------------------------------------------------------------------------------------
SKAN_RF:								 ;AVTOPOISK RAZGOVORA RFPI I SINXRONIZACII
				   CLR SLOT_SINC         ;SBROS SLOT SINXRONIZACII
				   CLR SCAN_PAK          ;ZAPRET POISKA BAZARA
				   CALL	CLR_S            ;STERET SIMVOL SINXRONIZACII
				   CLR TST				 ;SBROSIT ENA EMUL
				   CALL CLR_E			 ;STERET SIMVOL EMUL
				   MOV TEMP_PAK1,#000H	 ;SBROS STARIX MAC ADRESOV
				   MOV TEMP_PAK2,#000H
				   MOV TEMP_PAK3,#000H
				   MOV TEMP_PAK4,#000H
				   MOV TEMP_PAK5,#000H
				   MOV RFPI1,#000H	     ;SBROS YCEEK SINXRONIZACII
				   MOV RFPI2,#000H
				   MOV RFPI3,#000H
				   MOV RFPI4,#000H
				   MOV RFPI5,#000H
				   CALL PRINT_TXT_MAC     ;STERET STRIY RFPI S EKRANA

                   MOV A,N_CAN 			 ;V BUFER KANAL
				   MOV DPTR,#SINTTAB     ;ADRES TABLICI SINTEZA V DPTR
				   MOVC A,@A+DPTR        ;IZVLECENIE CISLA SINTEZA IZ TABLICI
				   CALL LOAD             ;VIZOV ZAPISI
				   NOP
				   MOV LCDADR,#006H		 ;ADRES 6 OTSTUP DLA TEKSTA
				   CALL set_lcd_adr
				   MOV A,N_CAN
				   ADD A,#030H
				   MOV LCDDATA,A
				   CALL print_char

				   MOV R3,#00FH
met2:
				   CALL ZADO			 ;ZADERGKA DLA USPOKOENIYA ENA
				   DJNZ R3,met2

				   CLR ET0               ;PRERIVANIE KLAVIATURY ZAGLUSENO
				   CLR BAZAR_PAK	     ;SBROS OBNARUZENIE PAKETA
				   SETB SCAN_PAK         ;RAZRESENIE POISKA BAZARA				   
				   MOV R3,#00CH          ;V SCETCIK PROXODOV ZADERGKA DLY OBNARUGENIYA PAKETA
				   
met0:
                   CALL ZADO      		 ;ZADERGKA 900 MKS
				   JB BAZAR_PAK,BAZAR	 ;ESLI 1 TO BAZAR POTTVERGDEN
				   DJNZ R3,met0			 ;PROVERIT SCETCIK PROXODOV ESLI ON ZACONCILIS TO VIXOD

										 ;BAZAR NE NAYDEN SMENA KANALA
				   SETB ET0              ;PRERIVANIE KLAVIATURY RAZRESENO
				   CLR SCAN_PAK          ;ZAPRET POISKA BAZARA
				   MOV A,N_CAN
		           XRL A,#009H           ;PROVERKA NA POSLEDNIY KANAL
		           JZ  met1		         ;ESLI POSLEDNIY TO SNACALA
				   INC N_CAN		     ;ESLI NET TO +1 V KANAL
				   RET
met1:              
                   MOV N_CAN,#000H       ;OCISTIT CANAL
				   RET																	   
      
BAZAR:             
                   SETB ET0              ;PRERIVANIE KLAVIATURY RAZRESENO
                   CLR SCAN_PAK          ;ZAPRET POISKA BAZARA
				   CLR BAZAR_PAK	     ;SBROS OBNARUZENIE PAKETA
                   SETB SLOT_SINC        ;PODNATIE SLOT SINXRONIZACII
				   CLR SCAN			     ;OCISTIT BIT SCANA
                   CALL PRINT_MAC
				   CALL PRINT_S          ;USTANOVIT SIMVOL SINXRONIZACII

				   MOV N_CAN,#000H       ;OCISTIT CANAL
                   RET
;--------------------------------------------------------------------------------------------------------
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX










;*********************************************************************************************************************
;  MODUL PROGRAMNOY INDIKACII (PRINT)
;-------------------------------------------------------------------------------------------------------------------

PRINT_MAC:
			     MOV LCDADR,#045H	   ;ADRES NA VTOROY STROKE OTSTUP 5 
			     CALL set_lcd_adr
			     MOV R1,#RFPI1         ;ADRES YACEYKI RFPI1 V R1
			     MOV R2,#005H          ;SCETCIK PROXODOV
PRINT_MAC_CIKL:			 
			     MOV A,@R1             ;IZVLEC V BUFER PO ADRESU V R1
			     SWAP A				   ;STARSIE V MLADSIE
			     ANL A,#00FH		   ;UBRAT LISNII STARSIE BIT
			     MOV DPTR,#HEX_LCD     ;ADRES TABLICI HEX_LCD
			     MOVC A,@A+DPTR        ;IZVLECENIE CISLA IZ TABLICI
			     MOV LCDDATA,A         ;						 
			     CALL print_char

			     MOV A,@R1             ;IZVLEC V BUFER PO ADRESU V R1
			     ANL A,#00FH		   ;UBRAT LISNII STARSIE BIT
			     MOV DPTR,#HEX_LCD     ;ADRES TABLICI HEX_LCD
			     MOVC A,@A+DPTR        ;IZVLECENIE CISLA IZ TABLICI
			     MOV LCDDATA,A         ;
			     CALL print_char

			     INC R1                ;+1 V R1 (ADRES)
			     DJNZ R2,PRINT_MAC_CIKL;ESLI NE OKONCILIS PROXODI PEREXOD
				 RET                   ;VOZWRAT
;--------------






;--------------
PRINT_TXT_MAC:
				     MOV LCDADR,#040H               ;ADRES NA VTOROY STROKE
			         CALL set_lcd_adr
                 
                     MOV R0,#000H
                     MOV DPTR,#TXT_RFPI              ;ADRES TABLICI V DPTR
PRINT_TXT_MAC_CIKL:
				     MOV A,R0
				     MOVC A,@A+DPTR                  ;IZVLECENIE CISLA IZ TABLICI
				     MOV LCDDATA,A                   ;						 
			         CALL print_char	             ;VIZOV ZAPISI
				     INC R0							 ;
				     MOV A,R0						 ;
				     CJNE A,#00FH,PRINT_TXT_MAC_CIKL ;ESLI CIKL NE ZAKONCILSY PEREXOD
					 RET                             ;VOZVRAT
;--------------



;--------------
PRINT_TXT_KANAL:
				     MOV LCDADR,#000H                ;ADRES NA PERVOY STROKE
			         CALL set_lcd_adr
                 
                     MOV R0,#000H
                     MOV DPTR,#TXT_KANAL              ;ADRES TABLICI V DPTR
PRINT_TXT_KANAL_CIKL:
				     MOV A,R0
				     MOVC A,@A+DPTR                   ;IZVLECENIE CISLA IZ TABLICI
				     MOV LCDDATA,A                    ;						 
			         CALL print_char	              ;VIZOV ZAPISI
				     INC R0							  ;
				     MOV A,R0						  ;
				     CJNE A,#007H,PRINT_TXT_KANAL_CIKL;ESLI CIKL NE ZAKONCILSY PEREXOD
					 RET                              ;VOZVRAT:
;--------------


;--------------
PRINT_S:
			         MOV LCDADR,#008H                ;ADRES
                 	 CALL set_lcd_adr
					 MOV LCDDATA,#053H               ;SIMVOL S
					 CALL print_char	             ;VIZOV ZAPISI
					 RET                             

CLR_S:
                     MOV LCDADR,#008H                ;ADRES
                 	 CALL set_lcd_adr
					 MOV LCDDATA,#020H               ;CLR
					 CALL print_char	             ;VIZOV ZAPISI
					 RET        
;--------------

PRINT_E:			
                     MOV LCDADR,#00AH                ;ADRES
                 	 CALL set_lcd_adr
					 MOV LCDDATA,#045H               ;SIMVOL E
					 CALL print_char	             ;VIZOV ZAPISI
					 RET  

CLR_E:				 
                     MOV LCDADR,#00AH                ;ADRES
                 	 CALL set_lcd_adr
					 MOV LCDDATA,#020H               ;CLR
					 CALL print_char	             ;VIZOV ZAPISI
					 RET
 ;--------------       	  

 ;--------------

PRINT_F:			
                     MOV LCDADR,#00CH                ;ADRES
                 	 CALL set_lcd_adr
					 MOV LCDDATA,#046H               ;SIMVOL F
					 CALL print_char	             ;VIZOV ZAPISI
					 RET  

CLR_F:				 
                     MOV LCDADR,#00CH                ;ADRES
                 	 CALL set_lcd_adr
					 MOV LCDDATA,#020H               ;CLR
					 CALL print_char	             ;VIZOV ZAPISI
					 RET
 ;--------------       	  
;*********************************************************************************************************************
			 









;*********************************************************************************************************************
;  ZAPIS V CIP SINTEZA
;-------------------------------------------------------------------------------------------------------------------
LOAD: 
			 RL A                  ;SDVIG 3 RAZA    5BIT NOMERA KANALA V STARSIX RAZRADAX
			 RL A
			 RL A
			 MOV SINDATA2,A        ;KOPIROVAT SODERGIMOE BUFERA V SINDATA2 STARSIE 5 BIT
								   ;START USLOVIE
			 SETB SYEN		       ;1-SYEN OBMEN RAZRESON
			 NOP
			 SETB SYDA			   ;1-SYDA
			 NOP
			 SETB SYCL			   ;1-SYCL
			 NOP
			 NOP
			 NOP
			 CLR SYCL			   ;0-SYCL START USLOVIE ZACONCENO

			 MOV A,SINDATA1        ;ZAGRUZKA 1 PROXODA STARSIE 5 BIT KONSTANTA V GLABNIY BUFER
			 CALL RFLOAD           ;VIZOV ZAPISI
			 MOV A,SINDATA2        ;ZAGRUZKA 2 PROXODA NOMER KANALA	V GLABNIY BUFER
			 CALL RFLOAD           ;VIZOV ZAPISI
								   ;STOP USLOVIE
			 CLR SYDA              ;0-SYDA
			 NOP
			 SETB SYCL			   ;1-SYCL
			 NOP
			 CLR SYCL			   ;0-SYCL
			 NOP
			 SETB SYDA			   ;1-SYDA
			 NOP
			 SETB SYCL			   ;1-SYCL
			 NOP
			 CLR SYEN		       ;0-SYEN OBMEN ZAPRESCEN

			 MOV R6,#064H          ;ZADERGKA
METCA2:
			 DJNZ R6,METCA2		   ;
			                       ;ZAPIS XVOSTICA PRODOLGENIE STOP USLOVIAE
			 SETB SYEN		       ;1-SYEN OBMEN RAZRESON
			 NOP
			 CLR SYDA              ;0-SYDA
			 NOP
			 CLR SYCL			   ;0-SYCL
			 NOP
			 SETB SYCL			   ;1-SYCL
			 NOP
			 CLR SYCL			   ;0-SYCL
			 NOP
			 SETB SYDA			   ;1-SYDA
			 NOP
			 SETB SYCL			   ;1-SYCL
			 NOP
			 CLR SYCL			   ;0-SYCL
			 NOP
			 SETB SYCL			   ;1-SYCL
			 NOP
			 CLR SYEN		       ;0-SYEN OBMEN ZAPRESCEN
			 RET                   ;GLAVNIY VIXOD

RFLOAD:
             MOV R7,#005H          ;ZAPIS 5 V SCETCIK PROXODOV R7
METCA1:
			 RLC A                 ;SDVIG BUFERA VLEVO CEREZ BIT PERENOSA
			 MOV SYDA,C            ;KOPIRUEM BIT PERENOSA V SINTEZATOR
			 SETB SYCL			   ;1-SYCL	ZAPISIVAEM EGO
			 NOP
			 CLR SYCL			   ;0-SYCL
		     DJNZ R7,METCA1        ;R7-1 PROVERIT NE ZAKONCILIS PROXOD
			 RET                   ;VOZWRAT
;*********************************************************************************************************************	












;*********************************************************************************************************************
;  OPROS KLAVIATURI
;------------------------------------------------------------------------------------------------------------------

TimerKL:
             PUSH ACC
			 PUSH PSW
			 PUSH 00H				 ;SOHRANENIE ISPOLZUEMIX YACEEK
             MOV P1,#11110000B       ;PROVERCA NA NAGATIE
			 MOV A,P1                ;
			 CJNE A,#11110000B,PROD  ;ESLI NE RAVHO TO PEREXOD NA PROD (KHOPKA HAGATA)
			 JB KEYOFF,KEYEND        ;ESLI BIT UGE STOIT VIXOD 
			 DJNZ KEYOFFTIME,KEYEND  ;ESLI SCECIC OTPUSKANIY NE OCISEN VIXOD BEZ PODNYTIY BITA OTPUSK
			 SETB KEYOFF             ;ESLI SCETCIK PROXODOV OKONCEN PODNIMAEM BIT OTPUSK
			 MOV KEYOFFTIME,#0FFH    ;VOSTANAVLIVAEM SCETCIK OTPUSKANIY

KEYEND:
             POP 00H
             POP PSW
			 POP ACC  				 ;VOSTONAVLENIE IX
			 RETI                    ;VIXOD IZ PRERIVANIYA

PROD:        
             MOV A,KEY1	             ;STAROE ZNACENIE CLAVIATURI V BUFER
             CJNE A,KEY2,SCANKEY     ;SRAVINT S NOVIM ESLI NET TO PEREXOD NA SCANKEY (NAGATA DRUGAY KNOPKA)
			 JB KEYON,KEYEND         ;PROVERKA NE PODNYT LI BIT SRABOTCI ESLI DA TO VIXOD
			 DJNZ KEYONTIME,SCANKEY  ;ESLI SCETCIK NE OKONCEN PRODOLGAEM SCANIROVAT
			 SETB KEYON              ;ESLI OCONCEN PODNYT BIT SRABOTCI
		     MOV KEYONTIME,#0FFH	 ;VOSTANAVLIVAEM SCETCIK SRABOTKI
			 JMP KEYEND              ;VIXOD EST SRABOTKA

SCANKEY:
             MOV P1,#11110000B
			 MOV R0,P1
			 MOV P1,#00001111B
			 MOV A,P1
			 ADD A,R0
			 MOV KEY1,KEY2           ;PEREMESTIT STARIY NOVIY
			 MOV KEY2,A				 ;ZAPISIVAEM NOVOE ZNACENIE
			 MOV DPTR,#KEYTAB        ;ADRES TABLICI KONVERT ZAGRUGEN V DPTR
			 MOVC A,@A+DPTR          ;VIZOV PERECONVERTIROVANIY IZ TABLICI
			 MOV KEYVEL,A            ;ZAPISANA NOMER NOGATOY KNOPKI
			 JMP KEYEND              ;VIXOD ZAPISANO NOVOE ZNACENIE
;*********************************************************************************************************************











;*********************************************************************************************************************
;MODUL INDICATORA  (APARATNIY)
;-------------------------------------------------------------------------------------------------------------------

;--------------
;INICIALIZACIYA
INTLCD:
			 MOV R3,#006H            ;ZAPIS V R3 PROXODOV
MT1:    
             CALL LCDSVOB
	         MOV A,R3                ; 
			 MOV DPTR,#LCDINTTAB     ;ADRES TABLICI V DPTR
			 MOVC A,@A+DPTR          ;IZVLECENIE CISLA IZ TABLICI
			 MOV B,A				 ;EGO V PROMEZUTOCNIY BUFER 
			 ANL A,#0F0H			 ;UBRAT LISSNEE MLADSIE BIT
			 ANL P2,#00FH			 ;OCISTIT STARSIE 4 BITA
			 ORL P2,A                ;IZ BUFERA V PORT STARSIE 4 BITA
			 CLR RW
	         CLR RS                  ;0=RS ZAPIS V SLUGEBNIY REGISTR
			 NOP
			 SETB E
			 NOP				     ;ZAPISIVAEM EGO
			 CLR E
			 MOV A,B
			 SWAP A                  ;MLADSIE 4 BITA VPERED
			 ANL A,#0F0H			 ;UBRAT LISSNEE MLADSIE BIT
			 ANL P2,#00FH			 ;OCISTIT STARSIE 4 BITA
			 ORL P2,A                ;IZ BUFERA V PORT MLADSIE 4 BITA
			 CLR RW
	         CLR RS                  ;0=RS ZAPIS V SLUGEBNIY REGISTR
			 NOP
			 SETB E
			 NOP				     ;ZAPISIVAEM EGO
			 CLR E
			 

			 DJNZ R3,MT1             ;PROVERCA NE ZACONCILIS LI PROXODI
			 RET             
;--------------



;--------------
;ZAGRUZKA ADRESA I DANNYX LCD 
set_lcd_adr:
             CALL LCDSVOB		     ;GDEM GOTOVNOST LCD
		     ORL LCDADR,#080H	     ;DOBAVIT ADRESNUY SIGNATURY
			 MOV A,LCDADR
			 ANL A,#0F0H			 ;UBRAT LISSNEE MLADSIE BIT
			 ANL P2,#00FH			 ;OCISTIT STARSIE 4 BITA
			 ORL P2,A                ;ZGRUZAEM ADRES  STARSIE 4BIT
			 CLR RW
			 NOP
	         CLR RS                  ;0=RS ZAPIS V SLUGEBNIY REGISTR
			 NOP
			 SETB E
			 NOP				     ;ZAPISIVAEM EGO
			 CLR E
			 MOV A,LCDADR
			 SWAP A                  ;MLADSIE 4 BITA VPERED
			 ANL A,#0F0H			 ;UBRAT LISSNEE MLADSIE BIT
			 ANL P2,#00FH			 ;OCISTIT STARSIE 4 BITA
			 ORL P2,A                ;IZ BUFERA V PORT MLADSIE 4 BITA
			 CLR RW
			 NOP
	         CLR RS                  ;0=RS ZAPIS V SLUGEBNIY REGISTR
			 NOP
			 SETB E
			 NOP				     ;ZAPISIVAEM EGO
			 CLR E					 
			 RET

print_char:	
             CALL LCDSVOB         		 
			 MOV A,LCDDATA           ;ZAGRUGAEM DATA
			 ANL A,#0F0H			 ;UBRAT LISSNEE MLADSIE BIT
			 ANL P2,#00FH			 ;OCISTIT STARSIE 4 BITA
			 ORL P2,A				 ;IZ BUFERA V PORT STARSIE 4 BITA
			 SETB RS                 ;1=RS ZAPIS V REGISTR INDICACII
			 NOP
			 CLR RW
			 SETB E
			 NOP				     ;ZAPISIVAEM EGO
			 CLR E
			 MOV A,LCDDATA           ;ZAGRUGAEM DATA
			 SWAP A                  ;MLADSIE 4 BITA VPERED
			 ANL A,#0F0H			 ;UBRAT LISSNEE MLADSIE BIT
			 ANL P2,#00FH			 ;OCISTIT STARSIE 4 BITA
			 ORL P2,A                ;IZ BUFERA V PORT MLADSIE 4 BITA
			 SETB RS                 ;1=RS ZAPIS V REGISTR INDICACII
			 CLR RW
			 NOP
			 SETB E
			 NOP				     ;ZAPISIVAEM EGO
			 CLR E			
			 RET

LCDSVOB:	           				 ;GDEM OSVOBOGDENIYA LCD			                   
			 ORL P2,#0F0H
			 CLR RS
			 NOP
			 SETB RW
			 NOP
			 SETB E
			 NOP
			 MOV A,P2
			 NOP
			 CLR E
			 NOP
			 SETB E
			 NOP
			 CLR E
			 NOP
			 CLR RW
			 JB ACC.7,LCDSVOB	     ;PROVERAEM 7 BIT OGIDAEM OSVOBOGDENIYA
			 RET
;--------------
;*********************************************************************************************************************









;*********************************************************************************************************************
;MODUL OBNARUGENIYA I OBRABOTKI PRERIVANIYA PAKETA
;-------------------------------------------------------------------------------------------------------------------

PAKET:
             PUSH ACC
			 PUSH PSW
			 PUSH 000H
			 PUSH 001H
			 PUSH 002H				 ;SOHRANENIE ISPOLZUEMIX YACEEK
			 MOV R0,#000H			 ;OCISTIT ADRESNIY REGISTR
			 MOV R1,#PAK0			 ;ADRES PERVOY YACEEICI V R1
			 MOV R2,#006H            ;ZAGRUZIT SCETCIK PROXODOV
copy_pack:
			 MOVX A,@R0				 ;IZVLEC IZ RAM BLOKA V BUFER
			 MOV @R1,a				 ;IZ BUFERA V YACEYCU PO ADRESU R1 +
			 INC R0
			 INC R1
			 DJNZ R2,copy_pack		    ;ESLI NE OKONCILIS PROXODI PEREXOD
			 JB SLOT_SINC,SLOT_SINC_MT  ;PROVERIT NE USTANOVLEN LI BIT ZAXVATA SLOT SINXRONIZACII ESI DA TO NACAT PRECEDURY PROVERCI
			 JB SCAN_PAK,BAZ_RFPI       ;PROVERIT NE USTANOVLEN LI BIT PROCEDURIY POISKA RAZGOVORNOGO MAC
			 JMP EXT_PAK			    ;ESLI NICEGO NE USTANOVLENO TO VIXOD

SLOT_SINC_MT:
			 MOV A,PAK0              ;V BUFER HEADER PAKETA
		     ANL A,#00001110B        ;OTSEYAT LISNEE
			 JNZ EXT_PAK             ;ESLI BUFER NE 0 TO NET B-FILED
			 MOV A,PAK1				 ;
			 CJNE A,RFPI1,ERR_RFPI   ;SRAVNIVAEM S SODERGIMIM RFPI
			 MOV A,PAK2
			 CJNE A,RFPI2,ERR_RFPI
			 MOV A,PAK3
			 CJNE A,RFPI3,ERR_RFPI
			 MOV A,PAK4
			 CJNE A,RFPI4,ERR_RFPI
			 MOV A,PAK5
			 CJNE A,RFPI5,ERR_RFPI
			 MOV ERROR_RFPI,#000H    ;OCISTIT SCETCIK OSIBOK
			 SETB SINC_SLOT			 ;DERNUT NOGKOY SINXRONIZACII
			 CLR SINC_SLOT           ;
			 JMP EXT_PAK
ERR_RFPI:			 
			 MOV A,ERROR_RFPI
			 XRL A,#003H			 ;VELICINA DOPUSKAEMIX OSIBOK
			 JZ EXT_PAK	             ;ESLI SCETCIK OSIBOK PEREPOLNEN TO VIXOD BEZ SINXRONIZACII
			 INC ERROR_RFPI          ;+1 V SCETCIK OSIBOK
			 NOP
			 NOP
			 NOP
			 SETB SINC_SLOT			 ;DERNUT NOGKOY SINXRONIZACII
			 CLR  SINC_SLOT          ;
;--------------


EXT_PAK:
			 POP 002H
			 POP 001H
			 POP 000H
             POP PSW
			 POP ACC  				 ;VOSTONAVLENIE IX
			 RETI                    ;VIXOD IZ PRERIVANIYA


;--------------			 			 
BAZ_RFPI:
		     JB BAZAR_PAK,EXT_PAK    ;ESLI BIT UGE STOIT VIXOD
             MOV A,PAK0              ;V BUFER HEADER PAKETA
		     XRL A,#061H             ;
			 JNZ EXT_PAK             ;ESLI BUFER NE 0 TO PAKET NE SODERGIT RFPI ILI NET B-FILED 
			 MOV A,TEMP_PAK1		 ;PROVERKA SOVPADENII SO STARIM ZNACENIEM
			 CJNE A,PAK1,ERR_BAZ_RFPI;ESLI NET SOVPADENIYA TO PEREXOD
			 MOV A,TEMP_PAK2		 ;PROVERKA SOVPADENII SO STARIM ZNACENIEM
			 CJNE A,PAK2,ERR_BAZ_RFPI;ESLI NET SOVPADENIYA TO PEREXOD
			 MOV A,TEMP_PAK3		 ;PROVERKA SOVPADENII SO STARIM ZNACENIEM
			 CJNE A,PAK3,ERR_BAZ_RFPI;ESLI NET SOVPADENIYA TO PEREXOD
			 MOV A,TEMP_PAK4		 ;PROVERKA SOVPADENII SO STARIM ZNACENIEM
			 CJNE A,PAK4,ERR_BAZ_RFPI;ESLI NET SOVPADENIYA TO PEREXOD
			 MOV A,TEMP_PAK5		 ;PROVERKA SOVPADENII SO STARIM ZNACENIEM
			 CJNE A,PAK5,ERR_BAZ_RFPI;ESLI NET SOVPADENIYA TO PEREXOD
			 SETB BAZAR_PAK			 ;SOVPADENIE NAYDENO PODNIMAEM OBNARUZENIE PAKETA
			 SETB SINC_SLOT			 ;DERNUT NOGKOY SINXRONIZACII
			 CLR  SINC_SLOT          ;
			 MOV RFPI1,PAK1			 ;KOPIRUEM RFPI V YACEYKI SINXRONIZACII
			 MOV RFPI2,PAK2
			 MOV RFPI3,PAK3
			 MOV RFPI4,PAK4
			 MOV RFPI5,PAK5
			 JMP EXT_PAK             ;VIXOD

ERR_BAZ_RFPI:
             MOV TEMP_PAK1,PAK1      ;COPIRUEM NOVOE ZNACENIE
			 MOV TEMP_PAK2,PAK2
			 MOV TEMP_PAK3,PAK3
			 MOV TEMP_PAK4,PAK4
			 MOV TEMP_PAK5,PAK5
			 SETB SINC_SLOT			 ;DERNUT NOGKOY SINXRONIZACII POPITKA SINXRONIZACII
			 CLR  SINC_SLOT          ;
			 JMP EXT_PAK             ;VIXOD
                 		     
;*********************************************************************************************************************





;*********************************************************************************************************************
;TABLICA KONVERTIROVANIYA KLAVIATURI
KEYTAB:
	        db 0,0,0,0,  0,0,0,0,  0,0,0,0,  0,0,0,0     
	        db 0,0,0,0,  0,0,0,0,  0,0,0,0,  0,0,0,0     
	        db 0,0,0,0,  0,0,0,0,  0,0,0,0,  0,0,0,0     
	        db 0,0,0,0,  0,0,0,0,  0,0,0,0,  0,0,0,0
	        db 0,0,0,0,  0,0,0,0,  0,0,0,0,  0,0,0,0
	        db 0,0,0,0,  0,0,0,0,  0,0,0,0,  0,0,0,0
	        db 0,0,0,0,  0,0,0,0,  0,0,0,0,  0,0,0,0
	        db 0,0,0,0,  0,0,0,07H,0,0,0,08H,0,09H,0CH,0     ;(07) (08) (09) (x 12)
	        db 0,0,0,0,  0,0,0,0,  0,0,0,0,  0,0,0,0
	        db 0,0,0,0,  0,0,0,0,  0,0,0,0,  0,0,0,0
	        db 0,0,0,0,  0,0,0,0,  0,0,0,0,  0,0,0,0
	        db 0,0,0,0,  0,0,0,04H,0,0,0,05H,0,06H,0DH,0	 ;(04) (05) (06) (- 13)
	        db 0,0,0,0,  0,0,0,0,  0,0,0,0,  0,0,0,0
	        db 0,0,0,0,  0,0,0,01H,0,0,0,02H,0,03H,0EH,0	 ;(01) (02) (03) (+ 14)
	        db 0,0,0,0,  0,0,0,0AH,0,0,0,00H,0,0BH,0FH,0     ;(SHIFT 10) (00) (ENTER 11) (= 15)
	        db 0,0,0,0,  0,0,0,0,  0,0,0,0,  0,0,0,0
;*********************************************************************************************************************
;TABLICA SINTEZA
SINTTAB:
            db 00BH,00DH,00FH,011H,013H,015H,017H,019H,01BH,01DH
;*********************************************************************************************************************
;TABLICA INICIALIZ LCD
LCDINTTAB:
            db 0,001H,004H,00CH,028H,028H
;*********************************************************************************************************************

;TABLICA HEX_LCD
HEX_LCD:
			db 030H,031H,032H,033H,034H,035H,036H,037H,038H,039H,041H,042H,043H,044H,045H,046H
;*********************************************************************************************************************
;PRINT LCD
TXT_RFPI:
            db 'RFPI:**********'	
;*********************************************************************************************************************
TXT_KANAL:
            db 'KANAL:*'
;*********************************************************************************************************************
END


